9e13ae37042121c2e18148ca20c972a190224a4b
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidvhq"
42 typeset extension=""
43 typeset -i force_onepass_mode=0
44 typeset -i eject_disk=1
45 typeset -i keep_isofile=0
46 typeset -i keep_vobfile=0
47 typeset -i keep_dvdfolder=0
48 typeset -i keep_intermediate_files=0
49 typeset -i make_final_dest_vob=0
50 typeset -i make_final_dest_iso=0
51 typeset -i make_final_dest_folder=0
52 typeset -i make_final_dest_comp=0
53 typeset -i errors=0
54 typeset -i show_usage=0
55 typeset -i mirror_mode=0
56 typeset -i target_bitrate=2000
57 typeset -i target_size=0
58 typeset -i audio_2ch=0
59 typeset -i invalid_feature_title=0
60 typeset -i feature_title_override=0
61 typeset -i mplayer_dumpstream_incompatibility=0
62
63 ##############################################################################
64 # Local Machine Settings:
65 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
66 # and the local conf file created by each local machine (rip_dvd.conf)
67 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
68 # This will allow you to override all the default values to meet your needs
69 # in a way that won't get clobbered when you pull updates from my GIT repo.
70 ##############################################################################
71 config="${0%/*}/rip_dvd.conf"
72
73 # The config file will be searched for in the following location order:
74 found_config=0
75
76 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
77 [ -e "${config}.dist" ] && found_config=1 && . ${config}.dist
78
79 # 2) /path/to/rip_dvd/script/rip_dvd.conf
80 [ -e "${config}" ] && found_config=1 && . ${config}
81
82 # 3) /etc/rip_dvd.conf
83 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . /etc/rip_dvd.conf
84
85 # 4) $PWD/rip_dvd.conf
86 [ -e "rip_dvd.conf" ] && found_config=1 && . rip_dvd.conf
87
88 # Check to make sure we found the config file
89 if [ $found_config -eq 0 ]; then
90   echo "-E- Unable to find the rip_dvd.conf file: $config"
91   exit 1
92 fi
93
94 ##############################################################################################
95 # Command line processing
96 ##############################################################################################
97 while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j: opt "$@"
98 do
99     case $opt in
100         (n)     dvdname=$OPTARG;;
101         (d)     dest=$OPTARG;;
102         (b)     target_bitrate=$OPTARG;;
103         (s)     target_size=$OPTARG;;
104         (2)     audio_2ch=1;;
105         (1)     force_onepass_mode=1;;
106         (v)     make_final_dest_vob=1;;
107         (i)     make_final_dest_iso=1;;
108         (f)     make_final_dest_folder=1;; 
109         (x)     make_final_dest_comp=1;;
110         (m)     mirror_mode=1;;
111         (k)     keep_intermediate_files=1;;
112         (t)     feature_title_override=$OPTARG;;
113         (a)     aspect=$OPTARG;;
114         (p)     profile=$OPTARG;;
115         (e)     extension=$OPTARG;;
116         (j)     eject_disk=$OPTARG;;
117         (w)     set -$opt;;
118         (h)     show_usage=1;;
119         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
120         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
121     esac
122 done
123
124 shift $((OPTIND-1))
125
126 function usage() {
127     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
128     echo >&2 "Revision $REV"
129     echo >&2 "Options:"
130     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
131     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
132     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
133     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
134     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
135     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
136     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
137     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
138     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
139     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
140     #echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
141     #echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
142     #echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
143     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
144     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
145     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
146     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
147     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
148     echo >&2 "                 The default operation is non-mirror mode where only the main"
149     echo >&2 "                 feature title will be ripped."
150     echo >&2 "   -v            Make the final image a DVD VOB file"
151     echo >&2 "   -i            Make the final image a DVD ISO file"
152     echo >&2 "   -f            Make the final image a DVD folder"
153     echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
154     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
155     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
156     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
157     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
158     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
159     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
160     echo >&2 "   -j <n>        Eject the disk:"
161     echo >&2 "                 - 0 = do not eject the disk"
162     echo >&2 "                 - 1 = eject after the entire script is done (default)"
163     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
164     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
165     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
166     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
167     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
168     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
169     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
170     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
171     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
172     echo >&2 ""
173     exit 2
174 }
175
176 if (($errors)) || (($show_usage))
177 then
178   usage
179 fi
180
181 # Sanity Check - Command Line Options 
182 if [ "$dest" == "" ]; then
183   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
184   usage
185 fi
186
187 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
188   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
189   usage
190 fi
191
192 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
193   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
194   usage
195 fi
196
197 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
198    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
199   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
200   usage
201 fi
202
203 if [ $mirror_mode -eq 1 ]; then
204   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
205      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
206     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
207     usage
208   fi
209 fi
210
211 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
212 if [ "$aspect" != "" ]; then
213   echo "$aspect" | grep -q "x"
214   if [ $? == 0 ]; then
215     echo "-E- You must specify the aspect option with a value whose format is W:H"
216     exit 1
217   fi
218   echo "$aspect" | grep -q ":"
219   if [ $? != 0 ]; then
220     SCALE=",scale -zoom -sws 9 -xy $aspect"
221   else
222     SCALE=",scale=$aspect"
223   fi
224 fi
225
226
227 # Sanity Check - Key executables
228 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
229 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
230 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
231 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
232 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
233 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
234 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
235 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
236
237 ##############################################################################################
238
239 typeset -i ripdvd
240 if [ -z "$dvdname" ]; then
241
242   # make sure the DVD device is accessible
243   volname $dev > /dev/null 2>&1
244   if [ $? != 0 ]; then
245     echo "-E- Can't access the DVD device $dev"
246     exit 1
247   fi
248   # now capture the volume name from the device
249   dvdname=`volname $dev | awk '{ print $1 }'`
250   ripdvd=1
251
252 else 
253
254   # check to see if dvdname is a full path to a real directory
255   # if it is, set dvdname and dvdpath appropriately
256   if [ -d "$dvdname" ]; then
257     dvdpath="$dvdname"
258     dvdname=`basename "$dvdname"`
259     keep_dvdfolder=1
260     if [ -z "$dvdname" ]; then
261      echo "-E- Unable to extract dvdname from path: $dvdpath"
262      exit 1
263     fi
264     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
265       echo "-E- You must supply a full path to a valid DVD folder with this option"
266       exit 1
267     fi
268   fi
269
270   # Check to see if dvdname is a full path to a file
271   if [ -f "$dvdname" ]; then
272     valid_file=0
273
274     # check to see if dvdname is a full path to an MPG2 (VOB) file
275     # if it is, set dvdname and vobfile appropriately
276     file "$dvdname" | grep -q "MPEG"
277     if [ $? == 0 ]; then
278       # It is a valid MPEG2 file, now strip the extension off our dvdname
279       vobfile="$dvdname"
280       dvdname=`basename "$dvdname"`
281       dvdname=${dvdname%.[^.]*}
282       keep_vobfile=1
283       valid_file=1
284     fi
285
286     # check to see if dvdname is a full path to an ISO file
287     # if it is, set dvdname and isofile appropriately
288     file "$dvdname" | grep -q -e "ISO" -e "UDF"
289     if [ $? == 0 ]; then
290       # It is a valid ISO file, now strip the extension off our dvdname
291       isofile="$dvdname"
292       dvdname=`basename "$dvdname"`
293       dvdname=${dvdname%.[^.]*}
294       keep_isofile=1
295       valid_file=1
296     fi    
297
298     # If we didn't find a handler for the file above, complain
299     if [ $valid_file -eq 0 ]; then
300       echo "-E- Unsupported file type: $vobfile"
301       exit 1
302     fi
303
304   # Throw an error if we can't find what the -n option is pointing to
305   else 
306     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
307     exit 1
308   fi
309
310   # Set the ripdvd flag to false since we aren't ripping a DVD disk
311   ripdvd=0
312
313   # Since we aren't ripping a DVD disk, don't eject anything either
314   eject_disk=0
315
316 fi
317
318 # remove bad characters from the dvdname
319 dvdname=${dvdname%.} # remove trailing '.' character
320
321 # add the suffix extension to the end of the dvdname
322 dvdname=$dvdname$extension
323
324 # make a "safe" dvdname (remove special characters)
325 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
326
327 # Make sure we have a non-empty dvdname
328 if [ -z "$dvdname" ]; then
329   echo "-E- unable to determine dvdname"
330   exit 1
331 fi
332
333 # make sure our vobfile value is set
334 if [ -z "$vobfile" ]; then
335   vobfile="$dest/$dvdname.VOB"
336 fi
337
338 # set up some variables to hold various logfiles
339 logfile="$logdir/$dvdname.log"
340 passlogfile="$tmpdir/$safedvdname.log"
341 ddrescuelog=`tempfile`
342 dvdauthorlog=`tempfile`
343 encodelog=`tempfile`
344 dumplog=`tempfile`
345
346 # create the tmpdir if it doesn't already exist
347 if [ ! -d "$tmpdir" ]; then
348   mkdir -p "$tmpdir"
349   if [ $? != 0 ]; then
350     echo "-E- Unable to create the tmpdir: $tmpdir"
351     exit 1
352   fi
353 fi
354
355 # create the logdir if it doesn't already exist
356 if [ ! -d "$logdir" ]; then
357   mkdir -p "$logdir"
358   if [ $? != 0 ]; then
359     echo "-E- Unable to create the logdir: $logdir"
360     exit 1
361   fi
362 fi
363
364 ##############################################################################################
365 # cleanup functions
366 ##############################################################################################
367 cleanup() { 
368   if [ $keep_intermediate_files -eq 0 ]; then
369     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
370     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
371     [[ -e "$encodelog" ]] && rm -f "$encodelog"
372     [[ -e "$dumplog" ]] && rm -f "$dumplog"
373   else
374     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
375     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
376     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
377     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
378   fi
379   echo ""
380 }
381
382 fatal_and_exit() {
383   if [[ -z "$1" ]]; then
384     msg="-E- control-c killed us"
385   else
386     msg=$1
387   fi
388   echo -e 2>&1 "$msg" | tee -a "$logfile"
389   if [[ -n "$mailto" ]]; then
390     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
391   fi
392   keep_intermediate_files=1
393   exit 1
394 }
395
396 # Call our cleanup functions on INT and EXIT signals
397 trap fatal_and_exit INT
398 trap cleanup EXIT
399
400 ##############################################################################################
401 # processing functions
402 ##############################################################################################
403
404 # encode the vob file into a compressed file format
405 function encode_vob_file {
406
407   # Set a variable that we will use later to determine if we found a handler for $profile or not
408   typeset -i found_profile=0
409
410   # For a given profile, to override the 2 pass behavior to be single pass,
411   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
412   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
413   PASSES="1 2"
414
415   # Declare our default 2 pass variables
416   passlogfile_opt="-passlogfile $passlogfile"
417   pass_opt="pass=%PASS"
418
419   # Check the global force_onepass_mode. If it is set, change our variables appropriately
420   # to force 1-pass encoding across all profiles.
421   if [ $force_onepass_mode -eq 1 ]; then
422     PASSES="2"
423     passlogfile_opt=""
424     pass_opt=""    
425   fi
426
427   # XVID profile
428   if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
429     found_profile=1
430     final_output_file="$dest/$dvdname.avi"
431     mencoder_general_opts="$lang_opts $passlogfile_opt"
432     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
433     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
434     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
435
436     # Very High Quality (16fps)
437     if [ "$profile" == "xvidvhq" ]; then
438       video_encoder_opts[0]="bitrate=$target_bitrate"
439       video_encoder_opts[1]="threads=$mencoder_threads"
440       video_encoder_opts[2]="chroma_opt"
441       video_encoder_opts[3]="vhq=4"
442       video_encoder_opts[4]="bvhq=1"
443       video_encoder_opts[5]="quant_type=mpeg"
444       video_encoder_opts[6]="autoaspect"
445     fi
446     # High Quality (20fps)
447     if [ "$profile" == "xvidhq" ]; then
448       video_encoder_opts[0]="bitrate=$target_bitrate"
449       video_encoder_opts[1]="threads=$mencoder_threads"
450       video_encoder_opts[2]="chroma_opt"
451       video_encoder_opts[3]="vhq=2"
452       video_encoder_opts[4]="bvhq=1"
453       video_encoder_opts[5]="quant_type=mpeg"
454       video_encoder_opts[6]="autoaspect"
455     fi
456     # Fast (28fps)
457     if [ "$profile" == "xvid" ]; then
458       video_encoder_opts[0]="bitrate=$target_bitrate"
459       video_encoder_opts[1]="threads=$mencoder_threads"
460       video_encoder_opts[2]="vhq=0"
461       video_encoder_opts[3]="turbo"
462       video_encoder_opts[4]="autoaspect"
463     fi
464
465     for OPTS in "${video_encoder_opts[@]}"; do 
466       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
467     done
468
469     if [ $audio_2ch -eq 0 ]; then
470       # These options produce good 6 channel audio for linux and windows
471       mencoder_audio_opts="-oac copy"
472       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
473       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
474       mencoder_audioch_opts[1]="-af channels=6"
475       mencoder_audioch_opts[2]=""
476     else
477       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
478       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
479       mencoder_audioch_opts[0]=""
480     fi
481  
482   fi
483
484   # MP4 encoding profiles
485   # These are currently in BETA. They don't work that great. A new recipe is needed, for the audio.
486   if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
487     found_profile=1
488     final_output_file="$dest/$dvdname.mp4"
489     mencoder_general_opts="$lang_opts $passlogfile_opt"
490     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
491     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
492     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
493
494     # Very High Quality (6fps)
495     if [ "$profile" == "mp4vhq" ]; then
496       video_encoder_opts[0]="bitrate=$target_bitrate"
497       video_encoder_opts[1]="threads=$mencoder_threads"
498       video_encoder_opts[2]="subq=6"
499       video_encoder_opts[3]="frameref=5"
500       video_encoder_opts[4]="bframes=3"
501       video_encoder_opts[5]="8x8dct"
502       video_encoder_opts[6]="me=umh"
503       video_encoder_opts[7]="b_pyramid"
504       video_encoder_opts[8]="weight_b"
505       video_encoder_opts[9]="partitions=all" 
506     fi
507     # High Quality (13fps)
508     if [ "$profile" == "mp4hq" ]; then
509       video_encoder_opts[0]="bitrate=$target_bitrate"
510       video_encoder_opts[1]="threads=$mencoder_threads"
511       video_encoder_opts[2]="subq=5"
512       video_encoder_opts[3]="frameref=2"
513       video_encoder_opts[4]="bframes=3"
514       video_encoder_opts[5]="8x8dct"
515       video_encoder_opts[6]="b_pyramid"
516       video_encoder_opts[7]="weight_b"
517     fi
518     # Fast (17fps)
519     if [ "$profile" == "mp4" ]; then
520       video_encoder_opts[0]="bitrate=$target_bitrate"
521       video_encoder_opts[1]="threads=$mencoder_threads"
522       video_encoder_opts[2]="subq=4"
523       video_encoder_opts[3]="bframes=2"
524       video_encoder_opts[4]="b_pyramid"
525       video_encoder_opts[5]="weight_b"
526     fi
527
528     for OPTS in "${video_encoder_opts[@]}"; do
529       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
530     done
531
532     if [ $audio_2ch -eq 0 ]; then
533       # These options produce good 6 channel audio for linux and windows
534       #mencoder_audio_opts="-oac copy"
535       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
536       #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
537       #mencoder_audioch_opts[1]="-af channels=6"
538       #mencoder_audioch_opts[2]=""
539       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
540       mencoder_audioch_opts[0]="-channels 6 -srate 48000 -af volnorm=1"
541     else
542       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
543       #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
544       #mencoder_audioch_opts[0]=""
545       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
546       mencoder_audioch_opts[0]="-channels 2 -srate 48000 -af volnorm=1"
547     fi
548
549   fi
550
551   # iphone and ipod MP4 profiles
552   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
553     found_profile=1
554     if [ "$profile" == "iphone" ]; then
555       # SCALE: 480x320
556       # scale width to 480, set height appropriately, but keep a multiple of 16
557       #SCALE=",scale=480:-10"
558       # scale the video down however far is necessary to fit in 480x320
559       SCALE=",dsize=480:320:0,scale=-8:-8"
560     else
561       # SCALE: 320x240
562       # scale width to 320, set height appropriately, but keep a multiple of 16
563       #SCALE=",scale=320:-10"
564       # scale the video down however far is necessary to fit in 320x240
565       SCALE=",dsize=320:240:0,scale=-8:-8"
566     fi
567     final_output_file="$dest/$dvdname.mp4"
568     mencoder_general_opts="$lang_opts $passlogfile_opt"
569     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
570     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
571     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
572     video_encoder_opts[0]="bitrate=$target_bitrate"
573     video_encoder_opts[1]="threads=$mencoder_threads"
574     video_encoder_opts[2]="vbv_maxrate=1500"
575     video_encoder_opts[3]="vbv_bufsize=2000"
576     video_encoder_opts[4]="nocabac"
577     video_encoder_opts[5]="me=umh"
578     video_encoder_opts[6]="subq=6"
579     video_encoder_opts[7]="frameref=6"
580     video_encoder_opts[8]="trellis=1"
581     video_encoder_opts[9]="level_idc=30"
582     video_encoder_opts[10]="global_header"
583     video_encoder_opts[11]="bframes=0"
584     video_encoder_opts[12]="partitions=all"
585     for OPTS in "${video_encoder_opts[@]}"; do 
586       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
587     done
588
589     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
590     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
591   fi
592
593   if [ $found_profile -eq 0 ]; then
594     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
595   fi
596
597   # Do not edit this line. $mencoder_video_encoder_opts must be last
598   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
599   mencoder_retval=0
600
601   for PASS in $PASSES
602   do 
603     # Set some options based on which pass we are in
604     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
605     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
606     [ $PASS -eq 1 ] && output_file="/dev/null"
607     [ $PASS -eq 2 ] && output_file="$final_output_file"
608   
609     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
610     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
611     do
612       echo -e "   Encoding pass $PASS"
613       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
614       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
615       mencoder_retval=$? 
616       grep -q "\[channels\] Invalid" $encodelog
617       if [ $? != 0 ]; then          
618         break;
619       else
620         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
621       fi
622     done
623       
624     if [ $mencoder_retval != 0 ]; then
625       fatal_and_exit "-E- Unhandled mencoder error"
626     fi
627
628     # Concatenate the encode log to our main log file, greping out unwanted lines
629     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
630
631   done
632 }
633
634 function make_dvd_iso_image {
635
636   isofile="$1"
637
638   # check to see if we have a dvdpath to rip from instead of $dev
639   if [ -z "$dvdpath" ]; then
640     # load the CSS codes in the DVD drive 
641     lsdvd $dev >> "$logfile"
642     if [ $? != 0 ]; then
643       fatal_and_exit "-E- lsdvd $dev failed" 
644     fi
645
646     # read the DVD, ignoring/skipping CRC errors
647     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
648     if [ $? != 0 ]; then
649       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
650     fi
651     cat "$ddrescuelog" >> "$logfile"
652   else
653     # rip from a path instead
654     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
655   fi
656 }
657
658 function make_dvd_iso_image_from_folder {
659   
660   src="$1"
661   dst="$2"
662   handle_error=$3
663   
664   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
665
666   # make an iso image out of our directory
667   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
668   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
669
670   # set the audio languages from the iso if it exists and is non-zero in size
671   if [ -s "$dst" ]; then
672     get_feature_title "$dst"
673     get_audio_id_from_iso "$dst"
674   fi
675
676   # make sure we were able to create the iso image from the folder given to us
677   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
678     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
679     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
680     # remove the bad iso file
681     [[ -e "$dst" ]] && rm -f "$dst"
682     # get the feature title from the DVD folder
683     get_feature_title "$dvdpath"
684     # create our main VOB file from the ISO
685     create_main_vob_with_mplayer "$dvdpath" 
686     # get our audio id from the VOB file
687     get_audio_id_from_vob "$vobfile"
688   fi
689 }
690
691 function make_dvdbackup_folder_image {
692   # extract the feature title from the DVD image
693   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
694   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
695   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
696   if [ $? != 0 ]; then
697     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
698   fi
699 }
700
701 function make_dvdauthor_folder_image {
702   # create a new DVD video of the feature title
703   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
704   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
705   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
706   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
707
708   # There is a chance that dvdauthor won't like some of the VOBs.
709   # We can't tell ahead of time which ones it will choke on. 
710   # So, we need to run it over and over again until it can process
711   # all the VOBs. If it can't handle one of them, run it through
712   # mencoder to fix it and try again. These errors are typically
713   # present due to the copy protection that ddrescue removed.
714   grep -q "SCR moves" $dvdauthorlog
715   while [ $? == 0 ]; do
716     # fix bad vobs that get the "SCR moves backwards" error:
717     #  STAT: Processing VTS_01_0.VOB...
718     #  ERR:  SCR moves backwards, remultiplex input.
719     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
720     if [[ ! -f "$badvob" ]]; then
721       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
722     fi
723     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
724     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
725     mv -f $badvob.fixed $badvob
726     echo "-> Creating DVD video $dest/$dvdname"
727     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
728     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
729     grep -q "SCR moves" $dvdauthorlog
730   done
731 }
732
733 function get_feature_title {
734   source="$1"
735   # if a feature title was given on the command line, use it
736   if [ $feature_title_override -ne 0 ]; then
737     feature_title=$feature_title_override
738     return 0
739   fi
740   # otherwise, use lsdvd to figure it out
741   if [ $ripdvd -eq 1 ]; then
742     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
743   else 
744     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
745   fi
746 }
747
748 function create_main_vob_with_cat {
749   # cd to the feature title DVD folder
750   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
751   if [ $? != 0 ]; then
752     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
753   fi
754
755   # concatenate all the VOBs together into 1 giant VOB
756   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
757   cat $vobs > "$tmpdir/$dvdname.VOB"
758
759   # cd back to the dir we started from
760   popd > /dev/null 2>&1
761 }
762
763 function create_main_vob_with_mplayer {
764
765   # argument processing  
766   source="$1"
767   remove_dumplog=$2
768
769   # make sure we have a valid feature title
770   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
771     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
772   fi
773
774   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
775   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
776     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
777     msg="$msg We also detected another condition that requires us to use dumpstream. "
778     msg="$msg\n    Unable to rip this DVD in the mode you requested."
779     fatal_and_exit "$msg"
780   fi
781
782   # use mplayer to create the main VOB file
783   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
784   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
785   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
786   if [ $? != 0 ]; then
787     cat $dumplog | grep -v "^A:" >> "$logfile"
788     fatal_and_exit "-E- Mplayer Failed"
789   fi
790   cat $dumplog | grep -v "^A:" >> "$logfile"
791   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
792 }
793
794 function get_audio_id_from_iso {
795   # Adjust our audio ID to find the english audio stream
796   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
797   iso="$1"
798   aidcheck=`tempfile`
799   aid=128
800   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
801   grep -q "aid: $aid" $aidcheck
802   while [ $? == 1 ] && [ $aid -lt 159 ]; do
803     (( aid = aid + 1 ))
804     grep -q "aid: $aid" $aidcheck
805   done
806   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
807   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
808   # mencoder default DVD audio track language selection (english)
809   lang_opts="-aid $aid -alang en"
810 }
811
812 function get_crop_from_iso { 
813   FRAMES=10000
814   echo "-> Detecting black frame border crop value from ISO file"
815   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
816   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
817   [[ -e "md5sums" ]] && rm -f "md5sums"
818   CROP=`cat $dumplog | grep CROP | tail -1`
819   echo "   Found crop value of $CROP" >> "$logfile"
820   CROP=${CROP#* crop=}
821   CROP=${CROP%%\).*}
822   typeset -i CROPCHECK
823   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
824   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
825   if [ -z "$CROP" ]; then
826     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
827     return
828   fi
829   if [ $CROPCHECK -lt 0 ]; then 
830     CROP=""
831   else 
832     CROP=",crop=$CROP"
833   fi
834   echo "   Setting mencoder crop filter to: $CROP"
835 }
836
837 function get_crop_from_vob { 
838   FRAMES=10000
839   echo "-> Detecting black frame border crop value from VOB file"
840   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
841   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
842   [[ -e "md5sums" ]] && rm -f "md5sums"
843   CROP=`cat $dumplog | grep CROP | tail -1`
844   echo "   Found crop value of $CROP" >> "$logfile"
845   CROP=${CROP#* crop=}
846   CROP=${CROP%%\).*}
847   typeset -i CROPCHECK
848   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
849   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
850   if [ -z "$CROP" ]; then
851     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
852     return
853   fi
854   if [ $CROPCHECK -lt 0 ]; then 
855     CROP=""
856   else 
857     CROP=",crop=$CROP"
858   fi
859   echo "   Setting mencoder crop filter to: $CROP"
860 }
861
862 function get_audio_id_from_vob {
863   # Adjust our audio ID to find the english audio stream
864   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
865   vob="$1"
866   aidcheck=`tempfile`
867   aid=128
868   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
869   grep -q "Found audio stream: $aid" $aidcheck
870   while [ $? == 1 ] && [ $aid -lt 159 ]; do
871     (( aid = aid + 1 ))
872     grep -q "Found audio stream: $aid" $aidcheck
873   done
874   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
875   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
876   # mencoder default DVD audio track language selection (english)
877   lang_opts="-aid $aid -alang en"
878 }
879
880 function check_vob_for_corrupted_start {
881   # check to see if the beginning of the DVD has a form of copy protection
882   # where they have deliberately broken the first X number of frames of the DVD.
883   # If we don't skip these, our resulting VOB file will not play.
884   badvobcheck=`tempfile`
885   endpos=360
886   skip=0
887   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
888   if [ $? != 0 ]; then
889     fatal_and_exit "-E- Mencoder Failed"
890   fi
891   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
892   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
893     (( skip = skip + 5 ))
894     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
895     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
896     if [ $? != 0 ]; then
897       fatal_and_exit "-E- Mencoder Failed"
898     fi
899     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
900   done
901   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
902
903   # cat the giant VOB into mencoder to create a playable VOB file
904   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
905   if [ $? != 0 ]; then
906     fatal_and_exit "-E- Mencoder Failed"
907   fi
908 }
909
910 function check_vob_for_completeness {
911   # check to make sure we got out a complete VOB.
912   # there is another kind of copy protection where the VOB's may
913   # have "MPG EOF" frames in the middle of the stream. 
914   # this causes mencoder to not process the entire VOB, and exit without any errors.
915   # detect this by seeing how much smaller the dst vob is from the src vob.
916   MAX_FILESIZE_DELTA_PERCENT=70
917   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
918   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
919   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
920   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
921     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
922     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
923     create_main_vob_with_mplayer "$isofile"
924     [[ -e "$dumplog" ]] && rm -f $dumplog
925     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
926     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
927     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
928       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
929     fi
930   fi
931 }
932
933 function check_vob_for_too_many_video_packets {
934   # If our earlier algorithm to work around this failed, throw an error.
935   # check to see if this DVD has a protection scheme we don't know how to work around
936   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
937   # for some reason, the video is black, while the audio rolls, then the video finally comes
938   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
939   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
940   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
941   grep -q "Too many video packets in the buffer:" "$logfile"
942   if [ $? == 0 ]; then
943     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
944     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
945     create_main_vob_with_mplayer "$isofile"
946     grep -q "Too many video packets in the buffer:" $dumplog
947     if [ $? == 0 ]; then
948       [[ -e "$dumplog" ]] && rm -f $dumplog
949       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
950     fi
951     [[ -e "$dumplog" ]] && rm -f $dumplog
952   fi
953 }
954
955 function check_vob_for_a52_crc_errors {
956   # Let's see if we can playback our newly created VOB file without any errors.
957   # if there are issues, let's detect them now, and try to recreate the VOB
958   # there are some forms of copy protection that have missed above, that evidence
959   # themselves when we try to playback the VOB file. This was added to deal with
960   # the "a52: CRC check failed" copy protection scheme.
961   MAX_ERRORS=10
962   ENDPOS=120
963   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
964   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
965   cat $dumplog | grep -v "^A:" >> "$logfile"
966   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
967   if [ $errors -gt $MAX_ERRORS ]; then
968     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
969     create_main_vob_with_mplayer "$isofile"
970     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
971     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
972     if [ $? != 0 ]; then
973       cat $dumplog | grep -v "^A:" >> "$logfile"
974       fatal_and_exit "-E- Mplayer Failed"
975     fi
976     cat $dumplog | grep -v "^A:" >> "$logfile"
977     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
978     if [ $errors -gt $MAX_ERRORS ]; then
979       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
980     fi
981   fi
982   [[ -e "$dumplog" ]] && rm -f $dumplog
983 }
984
985 function calculate_bitrate_from_target_size {
986   # determine what our bitrate needs to be if a target size was specified instead
987   if [ $target_size -ne 0 ]; then
988     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
989     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
990     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
991   fi
992 }
993
994 function create_dvdauthor_dvd_xml_file {
995   # make a dvdauthor xml menu file to create a valid DVD video from 
996   # this script does a good job, but we'll still need to clean it up a bit after it runs
997   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
998   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
999   if [ $? != 0 ]; then
1000     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1001   fi
1002
1003   # replace the first line of the xml file to remove the bad dest path
1004   awk -v line=1 -v new_content="<dvdauthor>" '{
1005     if (NR == line) {
1006       print new_content;
1007     } else {
1008       print $0;
1009     }
1010   }' dvd.xml > dvd.xml.new
1011   mv -f dvd.xml.new dvd.xml
1012   if [ $? != 0 ]; then
1013     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1014   fi
1015
1016   # remove the "<video " property line from the xml file
1017   cat dvd.xml | grep -v "<video" > dvd.xml.new
1018   mv -f dvd.xml.new dvd.xml
1019   if [ $? != 0 ]; then
1020     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1021   fi
1022   
1023   # remove the extra <pgc>..</pgc> pairs
1024   cat dvd.xml | awk 'BEGIN {x=1}
1025   {
1026     if ($0~"</pgc>") {x=0}
1027     if (x==1) {print $0}
1028     if ($0~"<pgc>") {x=1}
1029   }' > dvd.xml.new
1030   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1031   mv -f dvd.xml.new dvd.xml
1032   if [ $? != 0 ]; then
1033     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1034   fi
1035
1036   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1037   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1038   mv -f dvd.xml.new dvd.xml
1039   if [ $? != 0 ]; then
1040     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1041   fi
1042 }
1043
1044 function check_for_mplayer_dumpstream_incompatibility {
1045
1046   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1047
1048   if [ ! -e "$vobfile" ]; then
1049     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1050     # A DVD that has 99 titles, where the longest title isn't the main feature
1051     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1052     # out what the feature title is. This script will run through that flow if we
1053     # set use_mplayer_dumpstream to 0. Check for this here.
1054     if [ $ripdvd -eq 1 ]; then
1055       lsdvd $dev | grep -q "Title: 99"
1056     else
1057       lsdvd "$isofile" | grep -q "Title: 99"
1058     fi
1059     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1060     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1061       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1062         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1063         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1064         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1065         invalid_feature_title=1
1066       else 
1067         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1068         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1069         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1070         use_mplayer_dumpstream=0
1071         invalid_feature_title=1
1072       fi
1073       return
1074     fi
1075   fi
1076
1077   # There is another form of protection that causes the mplayer dumpstream to fail. 
1078   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1079   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1080   # problem before continuing.
1081   if [ -e "$vobfile" ]; then
1082     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1083     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1084     grep -q "Too many audio packets in the buffer" $dumplog
1085     if [ $? == 0 ]; then
1086       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1087       use_mplayer_dumpstream=0
1088       mplayer_dumpstream_incompatibility=1
1089     fi
1090     [[ -e "$dumplog" ]] && rm -f $dumplog
1091   fi
1092 }
1093
1094 function fill_mythvideo_metadata {
1095
1096   # This function must be passed the filename as an argument
1097   # The filename must be a full path to the file
1098   filename="$1"
1099
1100   # Make sure the fill mythvideo metadata option has been set to 1
1101   if [ $fill_mythvideo_metadata -eq 0 ]; then
1102     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1103     return 0
1104   fi
1105
1106   # If the fill mythvideo metadata script is present, run it
1107   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1108   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1109     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1110     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1111   else
1112     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1113     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1114   fi
1115 }
1116
1117 # remove the intermediate VOB file
1118 function remove_intermediate_vob_file {
1119   if [ $keep_intermediate_files -eq 0 ]; then
1120     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1121   else
1122     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1123   fi
1124 }
1125
1126 # remove the original DVD image 
1127 function remove_intermediate_iso_file {
1128   [[ $keep_isofile -eq 1 ]] && return 1
1129   if [ $keep_intermediate_files -eq 0 ]; then
1130     [[ -e "$isofile" ]] && rm "$isofile"
1131   else
1132     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1133   fi
1134 }
1135
1136 # remove the intermediate dvdbackup folder
1137 function remove_intermediate_dvdbackup_folder {
1138   if [ $keep_intermediate_files -eq 0 ]; then
1139     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1140   else
1141     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1142   fi
1143 }
1144
1145 ##############################################################################################
1146 # MAIN
1147 ##############################################################################################
1148
1149 # Make a note of when this DVD rip started
1150 date=`date`
1151 echo -e "\n$date DVD rip started" >> "$logfile"
1152 echo "$cmd" >> "$logfile"
1153
1154 # Rip the DVD - Mirror Mode
1155 if [ $mirror_mode -eq 1 ]; then
1156   echo "-> Ripping DVD $dvdname to $dest"
1157
1158   # use ddrescue to make an ISO image of the disk
1159   make_dvd_iso_image "$dest/$dvdname.iso"
1160
1161   # add this video data to the mythtv DB
1162   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1163
1164   # eject the disk upon completion
1165   if [ $eject_disk -ne 0 ]; then
1166     eject -T $dev
1167   fi
1168
1169   date=`date`
1170   echo "$date DVD rip completed" | tee -a "$logfile"
1171
1172   if [[ -n "$mailto" ]]; then
1173     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1174   fi
1175
1176 fi
1177
1178 # Rip the DVD - Main Title Feature Only
1179 if [ $mirror_mode -eq 0 ]; then
1180
1181   # Rip image from DVD
1182   if [ $ripdvd -eq 1 ]; then
1183     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1184     # use ddrescue to make an ISO image of the disk
1185     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1186   fi
1187
1188   # Rip image from DVD path
1189   if [ -n "$dvdpath" ]; then
1190     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1191     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1192   fi
1193
1194   # make sure our isofile value is set
1195   if [ -z "$isofile" ]; then
1196     isofile="$tmpdir/$dvdname.iso"
1197   fi
1198      
1199   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1200
1201     if [ ! -e "$vobfile" ]; then
1202       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1203       
1204       # get the feature title from the ISO
1205       get_feature_title "$isofile"
1206  
1207       # get the crop value from the ISO
1208       get_crop_from_iso
1209
1210       # check for mplayer dumpstream incompatibilities
1211       # if they exist, this method will set this mode to 0.
1212       check_for_mplayer_dumpstream_incompatibility
1213
1214       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1215
1216         # get our audio id from the ISO file
1217         get_audio_id_from_iso "$isofile"
1218
1219         # create our main VOB file from the ISO
1220         create_main_vob_with_mplayer "$isofile"
1221      
1222         # remove the intermediate VOB file
1223         remove_intermediate_vob_file
1224
1225         # it's possible that our VOB is still corrupted in some manner
1226         # check to make sure it is still a good VOB before continuing.
1227         check_for_mplayer_dumpstream_incompatibility
1228
1229       fi
1230  
1231       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1232
1233         # use dvdbackup to make a DVD folder of the feature title
1234         make_dvdbackup_folder_image
1235   
1236         # create our main VOB file
1237         create_main_vob_with_cat
1238
1239         # get our audio id from the VOB file
1240         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1241   
1242         # check for corrupted VOB start
1243         check_vob_for_corrupted_start
1244  
1245         # check to make sure our VOB is complete
1246         check_vob_for_completeness
1247
1248         # check to make sure our VOB doesn't have too many video packets
1249         check_vob_for_too_many_video_packets
1250
1251         # check to make sure our VOB doesn't have a52 crc errors
1252         check_vob_for_a52_crc_errors
1253
1254         # remove the intermediate VOB file
1255         remove_intermediate_vob_file
1256
1257       fi
1258
1259       # remove the intermediate ISO file
1260       remove_intermediate_iso_file
1261
1262     else
1263       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1264       # get our audio id from the VOB file
1265       get_audio_id_from_vob "$vobfile"
1266       # get the crop value from the VOB
1267       get_crop_from_vob
1268     fi
1269
1270     # eject the DVD disk since we are finished with it
1271     [ $eject_disk -eq 2 ] && eject -T $dev
1272
1273     # encode the VOB file to a compressed file format
1274     if [ $make_final_dest_comp -eq 1 ]; then
1275       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1276
1277       # determine what our bitrate needs to be if a target size was specified instead
1278       calculate_bitrate_from_target_size        
1279      
1280       # encode the vob file into a compressed file format
1281       encode_vob_file
1282
1283       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1284         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1285         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1286       else
1287         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1288         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1289       fi
1290     fi
1291
1292   # add this video data to the mythtv DB
1293   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1294   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1295     
1296   else
1297
1298   # use dvdbackup to make a DVD folder of the feature title
1299   make_dvdbackup_folder_image
1300
1301   # cd to the feature title DVD folder
1302   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1303   if [ $? != 0 ]; then
1304     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1305   fi
1306   
1307   # create the dvd.xml file for dvdauthor
1308   create_dvdauthor_dvd_xml_file  
1309
1310   # make the final DVD folder image
1311   make_dvdauthor_folder_image
1312
1313   # add this video data to the mythtv DB
1314   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1315  
1316   # cd back to the dir we started from
1317   popd > /dev/null 2>&1
1318
1319   if [ $make_final_dest_iso -eq 1 ]; then
1320
1321     # make an iso image out of our directory
1322     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1323    
1324     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1325     if [ -s "$dest/$dvdname.iso" ]; then
1326       if [ $make_final_dest_folder -eq 0 ]; then
1327         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1328         # remove the folder of the DVD image now that we have a .iso version of it
1329         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1330       fi
1331     else
1332       # we created an empty iso file, remove it
1333       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1334       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1335       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1336     fi
1337  
1338     # add this video data to the mythtv DB
1339     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1340
1341   fi
1342
1343   fi
1344
1345   # remove the ddrescue DVD ISO image
1346   remove_intermediate_iso_file
1347
1348   # remove the tmp dvdbackup folder of the DVD image
1349   remove_intermediate_dvdbackup_folder
1350
1351   # eject the DVD disk upon completion
1352   [ $eject_disk -eq 1 ] && eject -T $dev
1353
1354   date=`date`
1355   echo "$date DVD rip completed" | tee -a "$logfile"
1356
1357   if [[ -n "$mailto" ]]; then
1358     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1359   fi
1360
1361 fi
1362
1363 ##############################################################################################